//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#define FolderName_Screenshots   "Screenshots"
#define ScreenshotSizeX          1024
#define ScreenshotSizeY          768
#define ScreenshotStartBar       -1
#define ScreenshotChartScale     -1
#define ScreenshotChartMode      -1

extern string __Goertzel             = "Goertzel settings";
extern string TimeFrame              = "Current time frame";
extern int    Price                  = PRICE_CLOSE;
extern int    BarToCalculate         = 1;
extern int    StartAtCycle           = 1;
extern int    UseTopCycles           = 10;
extern bool   UseCosineForWaves      = true;
extern bool   UseAdditionForSteps    = false;
extern bool   UseSquaredAmp          = true;
extern int    MaxPer                 = 64;
extern int    SampleSize             = 0;
extern int    WindowSizePast         = 100;
extern int    WindowSizeFuture       = 100;
extern color  FutureLineColor        = PaleVioletRed;
extern int    FutureLineStyle        = STYLE_DOT;
extern int    FutureLineDisplace     = 0;
extern bool   UseCycleList           = false;
extern int    Cycle1                 = 1;
extern int    Cycle2                 = 1;
extern int    Cycle3                 = 1;
extern int    Cycle4                 = 1;
extern int    Cycle5                 = 1;
extern int    Offset                 = 0;
extern bool   SubtractNoise          = false;
extern bool   ListOfCyclesVisible    = false;
extern string ListOfCyclesID         = "GortzelBrowser";
extern int    ListOfCyclesCorner     = 1;
extern color  ListOfCyclesTextColor  = DimGray;
extern color  ListOfCyclesValueColor = PaleVioletRed;
extern bool   Interpolate            = true;

extern string  __General         = "General settings";
extern int     TradeHourStart    = 0;
extern int     TradeHourStop     = 6;
extern int     Lookahead         = 10;
extern int     Threshold         = 8;
extern double  BuyLo             = -0.015;
extern double  SellHi            =  0.015;
extern int     maTF              = 5;
extern bool    DoBuys            = true;
extern bool    DoSells           = true;
extern bool    CreateScreenshots = true;


extern int     MagicNumber = 1980;
extern bool    SignalMail = False;
extern bool    EachTickMode = true;
extern double  Lots = 0.1;
extern int     Slippage = 3;
extern bool    UseStopLoss = True;
extern int     StopLoss = 600;
extern bool    UseTakeProfit = True;
extern int     TakeProfit = 050;
extern bool    UseTrailingStop = False;
extern int     TrailingStop = 300;

double G00, G01, G02;
double GSlope;
double g[];
double f[];
static int     UpCount, DnCount;


double   on00, on01, on02, on03;
double   onf00, onf01, onf02, onf03;
double ma50, ma51;
double ma90, ma91;



int     TimeCount, TradeCount;
bool    ActionPoint, ActionPointMem;
bool    EndOfTrade;
bool    BuyMem, SellMem;
bool    ArmSell;

static bool    BuyActive,SellActive;
static bool    WasTrade;
static string  path_screenshots;


int BarCount, OldBars;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   if (Lookahead < 1) Lookahead = 1;
   Threshold = MathMin(Lookahead,MathMax(1,Threshold));
   TimeCount = Bars;
   TradeCount = 0;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   int k;
   double StopLossLevel, TakeProfitLevel;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
           if (Bars < 3*MaxPer)
                     { Comment(" Not Enough bars: you need 3*MaxPer -> " + DoubleToStr(3 * MaxPer, 0)); return (0); }
   
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

         if (ArrayRange(g,0)!=WindowSizePast) ArrayResize(g,WindowSizePast);
         if (ArrayRange(f,0)!=WindowSizeFuture) ArrayResize(f,WindowSizeFuture);
         UpCount = 0;
         DnCount = 0;
         for (k=0; k<MathMin(WindowSizePast,WindowSizeFuture); k++)
         {
            g[k] = iCustom(NULL, 0, "Goertzel5",TimeFrame,Price,BarToCalculate,StartAtCycle,UseTopCycles,UseCosineForWaves,UseAdditionForSteps,UseSquaredAmp,MaxPer,SampleSize,WindowSizePast,WindowSizeFuture,FutureLineColor,FutureLineStyle,FutureLineDisplace,UseCycleList,Cycle1,Cycle2,Cycle3,Cycle4,Cycle5,Offset,SubtractNoise,ListOfCyclesVisible,ListOfCyclesID,ListOfCyclesCorner,ListOfCyclesTextColor,ListOfCyclesValueColor,Interpolate, 0, k);
            f[k] = iCustom(NULL, 0, "Goertzel5",TimeFrame,Price,BarToCalculate,StartAtCycle,UseTopCycles,UseCosineForWaves,UseAdditionForSteps,UseSquaredAmp,MaxPer,SampleSize,WindowSizePast,WindowSizeFuture,FutureLineColor,FutureLineStyle,FutureLineDisplace,UseCycleList,Cycle1,Cycle2,Cycle3,Cycle4,Cycle5,Offset,SubtractNoise,ListOfCyclesVisible,ListOfCyclesID,ListOfCyclesCorner,ListOfCyclesTextColor,ListOfCyclesValueColor,Interpolate, 1, k);
            if (k>0 && (g[k] > g[0])) UpCount = UpCount + 1;
            if (k>0 && (g[k] < g[0])) DnCount = DnCount + 1;
         }
         ma50  =  iMA(NULL, maTF, 5, 0, MODE_SMA, PRICE_CLOSE, 0);
         ma51  =  iMA(NULL, maTF, 5, 0, MODE_SMA, PRICE_CLOSE, 1);
         ma90  =  iMA(NULL, maTF, 9, 0, MODE_SMA, PRICE_CLOSE, 0);
         ma91  =  iMA(NULL, maTF, 9, 0, MODE_SMA, PRICE_CLOSE, 1);


         
   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;
   bool BuyActive =False;
   bool SellActive = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() == OP_BUY) BuyActive = True;
      if (OrderType() == OP_SELL) SellActive = True;
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+



            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

            

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   
   if (

      (ma50 > ma90) &&
      (g[00] <= BuyLo) &&
      (g[00] < g[01]) &&
      (g[01] < g[02]) &&
      (g[02] < g[03]) &&
      (g[03] < g[04]) &&
      (g[04] < g[05]) &&
      (g[05] < g[06]) &&
      (g[06] < g[07]) &&
      (g[07] < g[08]) &&
      (g[08] < g[09]) &&
      (g[09] < g[10]) &&
      (g[10] < g[11]) &&

      (f[98] > f[99]) &&
      (f[97] > f[98]) &&
      (f[96] > f[97]) &&
      (f[95] > f[96]) &&
      (f[94] > f[95]) &&
      (f[93] > f[94]) &&
      (f[92] > f[93]) &&
      (f[91] > f[92]) &&
      (f[90] > f[91]) &&
      (f[89] > f[90]) &&
      (f[88] > f[89]) &&
      (f[87] > f[88]) &&
      (f[86] > f[87]) &&
      (f[85] > f[86]) &&
      (f[84] > f[85]) &&
      (f[83] > f[84]) &&
      (f[82] > f[83]) &&
      (f[81] > f[82]) &&
      (f[80] > f[81]) &&
      (f[79] > f[80]) &&
      (f[78] > f[79]) &&

      (0 != 1)
   )
   {
      Print("Buy");
      BuyMem = True;
      Order = Order + SIGNAL_BUY;
   }


   if (

      (ma50 < ma90) &&
      (g[00] >= SellHi) &&
      (g[00] > g[01]) &&
      (g[01] > g[02]) &&
      (g[02] > g[03]) &&
      (g[03] > g[04]) &&
      (g[04] > g[05]) &&
      (g[05] > g[06]) &&
      (g[06] > g[07]) &&
      (g[07] > g[08]) &&
      (g[08] > g[09]) &&
      (g[09] > g[10]) &&
      (g[10] > g[11]) &&

      (f[98] < f[99]) &&
      (f[97] < f[98]) &&
      (f[96] < f[97]) &&
      (f[95] < f[96]) &&
      (f[94] < f[95]) &&
      (f[93] < f[94]) &&
      (f[92] < f[93]) &&
      (f[91] < f[92]) &&
      (f[90] < f[91]) &&
      (f[89] < f[90]) &&
      (f[88] < f[89]) &&
      (f[87] < f[88]) &&
      (f[86] < f[87]) &&
      (f[85] < f[86]) &&
      (f[84] < f[85]) &&
      (f[83] < f[84]) &&
      (f[82] < f[83]) &&
      (f[81] < f[82]) &&
      (f[80] < f[81]) &&
      (f[79] < f[80]) &&
      (f[78] < f[79]) &&

      (0 != 1)
   )
   {
      Print("Sell");
      SellMem = True;
      Order = Order + SIGNAL_SELL;
   }

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   //Buy
   if (BuyMem && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!BuyActive) {
         BuyMem = false;
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            BuyActive = True;
            ArmSell = true;
            TradeCount++;
            if(CreateScreenshots) CreateScreenshot();
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (SellMem && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!SellActive) {
         SellMem = false;
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, Yellow);
         if(Ticket > 0) {
            SellActive = True;
            TradeCount++;
            if(CreateScreenshots) CreateScreenshot();
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;
   if (IsTrade && !WasTrade) WasTrade=true;
   if (WasTrade && !IsTrade)
      {
      WasTrade = false;
      if(CreateScreenshots) CreateScreenshot();
      }      
   if (!EachTickMode) BarCount = Bars;
   subWriteToChart();


   return(0);
}
//+------------------------------------------------------------------+

void subWriteToChart()
{

   int i,j;
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment + WindowExpertName()+ "  Balance=" + DoubleToStr(AccountBalance(),0)+ "  Equity=" + DoubleToStr(AccountEquity(),0) + NL;
   sComment = sComment + "Current Server DateTime = " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS) + NL;
   sComment = sComment + "TimeCount = " + (Bars-TimeCount) + "   TradeCount = " + TradeCount + NL;
   sComment = sComment + "DoBuys = " + DoBuys + "   DoSells = " + DoSells + NL;
   sComment = sComment + "BuyActive = " + BuyActive + "   SellActive = " + SellActive + NL;
   sComment = sComment + "BuyMem = " + BuyMem + "   SellMem = " + SellMem + NL;
   sComment = sComment + NL;
   sComment = sComment + "ActionPoint = " + ActionPoint + NL;
   sComment = sComment + NL;
   sComment = sComment + "UpCount = " + UpCount + "   DnCount = " + DnCount + NL;
   sComment = sComment + NL;
   for (i=0, j=WindowSizeFuture; i<10 ; i++, j--)
   {
      sComment = sComment + "       g[" + i + "] = " + DoubleToStr(g[i],4) + ", ";
      sComment = sComment + "       f[" + j + "] = " + DoubleToStr(f[j],4) + NL;
   }   
   sComment = sComment + NL;
   sComment = sComment + "          ma50 = " + DoubleToStr(ma50,4) + ", ";
   sComment = sComment + "          ma51 = " + DoubleToStr(ma51,4) + NL;
   sComment = sComment + "          ma90 = " + DoubleToStr(ma90,4) + ", ";
   sComment = sComment + "          ma91 = " + DoubleToStr(ma91,4) + NL;
   sComment = sComment + sp;
  
   Comment(sComment);
}

bool CreateScreenshot()
  {
   RefreshRates();
   subWriteToChart();
   datetime cur_time = TimeCurrent();
   string file_name = StringConcatenate(path_screenshots,"Screenshot_",IntegerToStr(TimeYear(cur_time),4),"_",IntegerToStr(TimeMonth(cur_time),2),"_",IntegerToStr(TimeDay(cur_time),2)," ",IntegerToStr(TimeHour(cur_time),2),"_",IntegerToStr(TimeMinute(cur_time),2),"_",IntegerToStr(TimeSeconds(cur_time),2),".gif");
   bool error = WindowScreenShot(file_name,ScreenshotSizeX,ScreenshotSizeY,ScreenshotStartBar,ScreenshotChartScale,ScreenshotChartMode);
   return(error);
  }

string IntegerToStr(int integer_number, int minimum_chars, string add_char = "0")
  {
   string result = DoubleToStr(integer_number,0);
   for(int i=minimum_chars-StringLen(result); i>0; i--) result = StringConcatenate(add_char,result);
   return(result);
  }


